<?php
/*
Plugin Name: Last.fm Recently Played Tracks
Plugin URI: http://ijustin.org/last-fm-widget
Description: Last.fm widget that supports customization for showing album art, how many tracks, and username. More customization to come soon! On load, uses jQuery (if JS enabled browser) to decrease page load time, but is still backwards compatible for non JS browsers. Shows track name, artist, and time played. No pesky "Support us" links.
Author: Justin Turner
Version: 1.0.9
Author URI: http://ijustin.org/
License: GPL2
*/
/*  Copyright 2010 Justin Turner (email : j.turner@ijustin.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
//this function is the actual widget that the end-user sees
function ij_lastfm_widget($args){
extract($args);
  $options = get_option("ij_lastfm_widget");
  if (!is_array($options))
{
$options = array(
		'title' => 'Last.fm Recently Placed',
		'username' => 'just_in_time90',
		'trackNum' => '5',
		'showArt' => '1',
		'showUI' => '1',
		'jsUpdate' => '1'
      );
  };
echo $before_widget;
echo $before_title.stripslashes($options['title']).$after_title;
?>
          <script type="text/javascript">
function CheckIt(checking)
{
var subSection = checking.substring(10,0).toLowerCase();
var answer = (subSection == "<div style");
if(answer){
jQuery("#ij_lastfm_widget").html(checking);
jQuery("#ij_lastfm_widget").show("slow");
}else{
jQuery("#ij_lastfm_widget").html("Something went wrong. We'll try again in a few minutes.");
jQuery("#ij_lastfm_widget").show("slow");
};
}
          /* <![CDATA[ */
function fetchLastfm(){
            jQuery.ajax({ // load tweets trough ajax to avoid waiting for lastfm's response
             type: "GET",url: "<?php bloginfo('url'); ?>",data: { username: '<?php echo $options['username']; ?>', trackNum: '<?php echo $options['trackNum']; ?>', showArt: '<?php echo $options['showArt']; ?>', showUI:'<?php echo $options['showUI']; ?>', get_ij_lastfm_data: 1 },
             beforeSend: function() {jQuery("#ij_loading_lastfm").show("slow");},
             complete: function() { jQuery("#ij_loading_lastfm").hide("fast");},
             success: function(html){
				CheckIt(html);
             }
            });
<?php
if($options['jsUpdate'] == 1){
echo 'setTimeout("fetchLastfm()",120000);';
};
?>
};
          // init
          jQuery(document).ready(function(){
			jQuery("#ij_loading_lastfm").html("Loading latest tracks...");
fetchLastfm();
          });
          /* ]]> */
          </script>
		<div id="ij_loading_lastfm"></div>
          <div id="ij_lastfm_widget"><noscript><?php fetch_ijlastfm_data($options['username'], $options['trackNum'], $options['showArt'], $options['showUI']); ?></noscript></div>
<?php
echo $after_widget;
};
//this is the function that gathers the data from last.fm and styles it nicely
function fetch_ijlastfm_data($username = 'just_in_time90',$trackNum = 3,$showArt = 1,$showUI = 1){
if(false === ($latest = get_transient('ij_lastfm_widget_'.$username))){
$request_url = "http://ws.audioscrobbler.com/2.0/?method=user.getrecenttracks&user=".$username."&limit=".$trackNum."&api_key=f02d8c8d50cd86d57bed580b6c6aeda3";
$ch = curl_init();
$timeout = 5;
curl_setopt($ch, CURLOPT_URL, $request_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
$latest = curl_exec($ch);
curl_close($ch);
set_transient('ij_lastfm_widget_'.$username, $latest, 120);
};
if(false === ($ui = get_transient('ij_lastfm_widget_uinfo_'.$username))){
$request_url = "http://ws.audioscrobbler.com/2.0/?method=user.getinfo&user=".$username."&api_key=f02d8c8d50cd86d57bed580b6c6aeda3";
$ch = curl_init();
$timeout = 5;
curl_setopt($ch, CURLOPT_URL, $request_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
$ui = curl_exec($ch);
curl_close($ch);
set_transient('ij_lastfm_widget_uinfo_'.$username, $ui, 120);
};
if(get_transient('ij_lastfm_widget_user_'.$username)){
delete_transient('ij_lastfm_widget_user_'.$username);
};

$latest = new SimpleXMLElement($latest);
$ui = new SimpleXMLElement($ui);
if($latest->xpath('//track')){
//gather user info
$upic = $ui->user->image[1];
$realname = $ui->user->realname;
$username = $ui->user->name;
$playcount = $ui->user->playcount;
$timejoin = $ui->user->registered['unixtime'];
$fromCountry = $ui->user->country;
if($showUI==1){
echo "<div style='clear:both;padding-top:3px;padding-bottom:3px;'>";
if($upic!=''){
echo "<img src='".$upic."' alt='Profile Pic for ".$username."' style='float:left;padding-right:5px;'/>";
};
if($realname!=''){
echo "<p style='font-weight:bold;padding:0px;margin:0px;'>".$realname."</p>";
};
echo "<p style='padding:0px;margin:0px;font-size:xx-small;'>".$username."</p>";
echo "<p style='padding:0px;margin:0px;font-size:xx-small;'>".$playcount." plays since ".date("F j Y",(int)$timejoin)."</p>";
echo "<p style='padding:0px;margin:0px;font-size:xx-small;'>Last.fm member for ".human_time_diff($timejoin)."</p>";
echo "</div>";
};
$i=0;
foreach($latest->xpath('//track') as $track){
//get all the info
	$title = $track->xpath('//name');
	$nowPlaying = $track->xpath('//track/@nowplaying');
	$datePlayed = $track->xpath('//date/@uts');
	$albumArt = $track->xpath('//image[@size="medium"]');
	$artist = $track->xpath('//artist');
//create the DIV
echo "<div style='clear:both;padding-top:3px;padding-bottom:3px;'>";
	if($showArt==1){
//do we want to show album art?
	if($albumArt[$i] != ""){
	echo "<img src='".$albumArt[$i]."'  width='52' height='52' alt='Album Art for".$title[$i]."' style='float:left;padding-right:5px;'/>";
	}else{
	echo "<img src='http://cdn.last.fm/flatness/catalogue/noimage/2/default_artist_medium.png' width='52' height='52' alt='No Album Art Available' style='float:left;padding-right:5px;'/>";
	};
	};
	echo "<p style='padding:0px;margin:0px;'>".$title[$i]."</p>";
	echo "<p style='padding:0px;margin:0px;font-size:xx-small;'>".$artist[$i]."</p>";
	//lets see if this song is currently playing...
	if($nowPlaying[$i] != ""){
	echo "<p style='padding:0px;margin:0px;font-size:xx-small;'>now playing!</p>";
	}else{
	echo "<p style='padding:0px;margin:0px;font-size:xx-small;'>about ".human_time_diff($datePlayed[$i])." ago</p>";
	};
	$i++;
echo "</div>";
	if($i == $trackNum){break;};
};
}else{
	echo "Something went wrong... Last.fm may be down. We'll try again in two and a half minutes.";
};
};
//this is the AJAX call function
function get_ij_lastfm_data(){
  if($_GET['get_ij_lastfm_data'] == 1){
    fetch_ijlastfm_data(wp_specialchars($_GET['username']), wp_specialchars($_GET['trackNum']), wp_specialchars($_GET['showArt']), wp_specialchars($_GET['showUI']));
    die();
  };
}
//add as an action so it can be called through AJAX
add_action('init', 'get_ij_lastfm_data');
//this is the control panel of the widget as seen on widget page
function ij_lastfm_widget_control()
{
  $options = get_option("ij_lastfm_widget");
  if (!is_array($options))
{
$options = array(
		'title' => 'Last.fm Recently Placed',
		'username' => 'just_in_time90',
		'trackNum' => '5',
		'showArt' => '1',
		'showUI' => '1',
		'jsUpdate' => '1'
      );
  };

if ($_POST['ij_lastfm_widget-Submit'])
	{
		$options['title'] = htmlspecialchars($_POST['ij_lastfm_widget-title']);
		$options['username'] = htmlspecialchars($_POST['ij_lastfm_widget-username']);
		$options['trackNum'] = htmlspecialchars($_POST['ij_lastfm_widget-trackNum']);
		$options['showArt'] = htmlspecialchars($_POST['ij_lastfm_widget-showArt']);
		$options['showUI'] = htmlspecialchars($_POST['ij_lastfm_widget-showUI']);
		$options['jsUpdate'] = htmlspecialchars($_POST['ij_lastfm_widget-jsUpdate']);
		update_option("ij_lastfm_widget", $options);
	}
 
?>
  <p>
    <label for="ij_lastfm_widget-title">Widget title:</label>
    <input type="text" id="ij_lastfm_widget-title" name="ij_lastfm_widget-title" value="<?php echo stripslashes($options['title']);?>" />
  </p>
  <p>
    <label for="ij_lastfm_widget-username">Last.fm username:</label>
    <input type="text" id="ij_lastfm_widget-username" name="ij_lastfm_widget-username" size="15" value="<?php echo stripslashes($options['username']);?>" />
  </p>
  <p>
    <label for="ij_lastfm_widget-trackNum">Number of tracks:</label>
<select id="ij_lastfm_widget-trackNum" name="ij_lastfm_widget-trackNum">
    <option value="1" <?php if($options['trackNum']==1){echo 'selected="selected"';};?>>1</option>
    <option value="2" <?php if($options['trackNum']==2){echo 'selected="selected"';};?>>2</option>
    <option value="3" <?php if($options['trackNum']==3){echo 'selected="selected"';};?>>3</option>
    <option value="4" <?php if($options['trackNum']==4){echo 'selected="selected"';};?>>4</option>
    <option value="5" <?php if($options['trackNum']==5){echo 'selected="selected"';};?>>5</option>
    <option value="6" <?php if($options['trackNum']==6){echo 'selected="selected"';};?>>6</option>
    <option value="7" <?php if($options['trackNum']==7){echo 'selected="selected"';};?>>7</option>
    <option value="8" <?php if($options['trackNum']==8){echo 'selected="selected"';};?>>8</option>
    <option value="9" <?php if($options['trackNum']==9){echo 'selected="selected"';};?>>9</option>
    <option value="10" <?php if($options['trackNum']==10){echo 'selected="selected"';};?>>10</option>
    <option value="11" <?php if($options['trackNum']==11){echo 'selected="selected"';};?>>11</option>
    <option value="12" <?php if($options['trackNum']==12){echo 'selected="selected"';};?>>12</option>
    <option value="13" <?php if($options['trackNum']==13){echo 'selected="selected"';};?>>13</option>
    <option value="14" <?php if($options['trackNum']==14){echo 'selected="selected"';};?>>14</option>
    <option value="15" <?php if($options['trackNum']==15){echo 'selected="selected"';};?>>15</option>
  </select>
  </p>
<p>
    <label for="ij_lastfm_widget-showArt">Show album art:</label>
<?php
if($options['showArt'] == 1){
?>
	<input type="checkbox" name="ij_lastfm_widget-showArt" value="1" checked />
<?php
}else{
?>
	<input type="checkbox" name="ij_lastfm_widget-showArt" value="1" />
<?php
};
?>
</p>
<p>
    <label for="ij_lastfm_widget-showUI">Show user info:</label>
<?php
if($options['showUI'] == 1){
?>
	<input type="checkbox" name="ij_lastfm_widget-showUI" value="1" checked />
<?php
}else{
?>
	<input type="checkbox" name="ij_lastfm_widget-showUI" value="1" />
<?php
};
?>
  </p>
<p>
    <label for="ij_lastfm_widget-jsUpdate">Javscript update every 2 minutes:</label>
<?php
if($options['jsUpdate'] == 1){
?>
	<input type="checkbox" name="ij_lastfm_widget-jsUpdate" value="1" checked />
<?php
}else{
?>
	<input type="checkbox" name="ij_lastfm_widget-jsUpdate" value="1" />
<?php
};
?>
  </p>
<input type="hidden" id="ij_lastfm_widget-Submit" name="ij_lastfm_widget-Submit" value="1" />
<?php
};
//this function registers the widget and control panel
function ij_lastfmWidget_init()
{
  register_sidebar_widget('Last.fm Widget','ij_lastfm_widget');
  register_widget_control('Last.fm Widget','ij_lastfm_widget_control',250,200);
}
//this function loads jquery in case it's not loaded prev
function ij_lastfm_loadjquery(){
wp_enqueue_script("jquery");
}
//this function loads everything
add_action("plugins_loaded", "ij_lastfmWidget_init");
add_action("plugins_loaded", "ij_lastfm_loadjquery");
?>